<?
/* 
   This file is part of the 'Science Fair In A Box' project
   SFIAB Website: http://www.sfiab.ca

   Copyright (C) 2005 Sci-Tech Ontario Inc <info@scitechontario.org>
   Copyright (C) 2005 James Grant <james@lightbox.org>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/
?>
<?
function registrationFormsReceived($reg_id="")
{
	if($reg_id) $rid=$reg_id;
	else $rid=$_SESSION['registration_id'];
	$q=mysql_query("SELECT status FROM registrations WHERE id='$rid'");
	$r=mysql_fetch_object($q);
	if($r->status=="complete" || $r->status=="paymentpending")
		return true;
	else
		return false;

}
function registrationDeadlinePassed()
{
	global $config;
	$q=mysql_query("SELECT (NOW()<'".$config['dates']['regclose']."') AS datecheck");
	$datecheck=mysql_fetch_object($q);
	if($datecheck->datecheck==1)
		return false;
	else
		return true;

}

function studentStatus($reg_id="")
{
	global $config, $conference;
	if($config['participant_student_personal']=="yes")
		$required_fields=array("firstname","lastname","address","city","postalcode","phone","email","grade","dateofbirth","schools_id","sex");
	else
		$required_fields=array("firstname","lastname","email","grade","schools_id");

	if($config['participant_student_tshirt']=="yes")
		$required_fields[]="tshirt";

	if($reg_id) $rid=$reg_id;
	else $rid=$_SESSION['registration_id'];

	$q=mysql_query("SELECT * FROM students WHERE registrations_id='$rid' AND conferences_id='".$conference['id']."'");

	//if we dont have the minimum, return incomplete
	if(mysql_num_rows($q)<$config['minstudentsperproject'])
		return "incomplete";

	while($r=mysql_fetch_object($q))
	{
		foreach ($required_fields AS $req)
		{
			if($req=="dateofbirth")
			{
				if($r->$req=="0000-00-00" || !$r->$req)
					return "incomplete";
			}
			else
			{
				if(!$r->$req)
					return "incomplete";
			}
		}
	}

	//if it made it through without returning incomplete, then we must be complete
	return "complete";
}

function emergencycontactStatus($reg_id="")
{
	global $conference;
	$required_fields=array("firstname","lastname","relation","phone1");

	if($reg_id) $rid=$reg_id;
	else $rid=$_SESSION['registration_id'];

	$sq=mysql_query("SELECT id FROM students WHERE registrations_id='$rid' AND conferences_id='".$conference['id']."'");
	$numstudents=mysql_num_rows($sq);

	while($sr=mysql_fetch_object($sq))
	{
		$q=mysql_query("SELECT * FROM emergencycontact WHERE registrations_id='$rid' AND conferences_id='".$conference['id']."' AND students_id='$sr->id'");

		$r=mysql_fetch_object($q);

		foreach ($required_fields AS $req)
		{
			if(!$r->$req)
			{
				return "incomplete";
			}
		}
	}

	//if it made it through without returning incomplete, then we must be complete
	return "complete";
}

function projectStatus($reg_id="")
{
	global $config, $conference;
	$required_fields=array("title","projectcategories_id","projectdivisions_id","language","req_table","req_electricity","summarycountok");

	if($config['participant_short_title_enable'] == 'yes') 
		$required_fields[] = 'shorttitle';

	if($config['participant_project_summary_wordmin'] > 0) 
		$required_fields[] = 'summary';

	if($reg_id) $rid=$reg_id;
	else $rid=$_SESSION['registration_id'];

	$q=mysql_query("SELECT * FROM projects WHERE registrations_id='$rid' AND conferences_id='".$conference['id']."'");

	//if we dont have a project entry yet, return empty
	if(!mysql_num_rows($q))
		return "empty";

	while($r=mysql_fetch_object($q))
	{
		foreach ($required_fields AS $req)
		{
			if(!$r->$req) {
				return "incomplete";
			}
		}
	}

	//if it made it through without returning incomplete, then we must be complete
	return "complete";
}


function mentorStatus($reg_id="")
{
	global $config, $conference;
	$required_fields=array("firstname","lastname","phone","email","organization","description");

	if($reg_id) $rid=$reg_id;
	else $rid=$_SESSION['registration_id'];

	//first check the registrations table to see if 'nummentors' is set, or if its null
	$q=mysql_query("SELECT nummentors FROM registrations WHERE id='$rid' AND conferences_id='".$conference['id']."'");
	$r=mysql_fetch_object($q);
	if($r->nummentors==null)
		return "incomplete";

	$q=mysql_query("SELECT * FROM mentors WHERE registrations_id='$rid' AND conferences_id='".$conference['id']."'");

	//if we dont have the minimum, return incomplete
	if(mysql_num_rows($q)<$config['minmentorserproject'])
		return "incomplete";

	while($r=mysql_fetch_object($q))
	{
		foreach ($required_fields AS $req)
		{
			if(!$r->$req)
			{
				return "incomplete";
			}
		}
	}

	//if it made it through without returning incomplete, then we must be complete
	return "complete";

}

function safetyStatus($reg_id="")
{
	global $conference;

	if($reg_id) $rid=$reg_id;
	else $rid=$_SESSION['registration_id'];

	//grab all of their answers
	$q=mysql_query("SELECT * FROM safety WHERE registrations_id='$rid'");
	while($r=mysql_fetch_object($q))
	{
		$safetyanswers[$r->safetyquestions_id]=$r->answer;
	}

	//now grab all the questions
	$q=mysql_query("SELECT * FROM safetyquestions WHERE conferences_id='".$conference['id']."' ORDER BY ord");
	while($r=mysql_fetch_object($q))
	{
		if($r->required=="yes" && !$safetyanswers[$r->id])
		{
			return "incomplete";
		}
	}
	return "complete";

}

function spawardStatus($reg_id="")
{
	global $conference;
	if($reg_id) $rid=$reg_id;
	else $rid=$_SESSION['registration_id'];

	$q=mysql_query("SELECT * FROM projects WHERE registrations_id='$rid'");
	$project=mysql_fetch_object($q);

	/* We want this query to get any awards with a NULL award_awards_id */
	$awardsq=mysql_query("SELECT
				projects.id AS projects_id
			FROM
				project_specialawards_link,
				projects
			WHERE
				project_specialawards_link.projects_id='".$project->id."'
				AND projects.conferences_id='".$conference['id']."'
				");

	if(mysql_num_rows($awardsq))
		return "complete";
	else
		return "incomplete";
}

function tourStatus($reg_id="")
{
	global $config, $conference;

	if($reg_id) $rid=$reg_id;
	else $rid=$_SESSION['registration_id'];

	/* Get the students for this project */
	$q=mysql_query("SELECT * FROM students WHERE registrations_id='$rid' AND conferences_id='".$conference['id']."'");
	$num_found = mysql_num_rows($q);

	$ret = "complete";
	while($s=mysql_fetch_object($q)) {
		//grab all of their tour prefs
		$sid = $s->id;
		$qq=mysql_query("SELECT * FROM tours_choice WHERE students_id='$sid' and conferences_id='{$conference['id']}' ORDER BY rank");

		$n_tours = mysql_num_rows($qq);
		if($n_tours > 0) {
			/* See if there's a rank 0 tour (rank 0 == their tour assignment) */
			$i = mysql_fetch_object($qq);
			if($i->rank == 0) {
				/* Yes, there is, no matter what, this student's tour
				 * selection is complete. */
				continue;
			}
		}

		/* Else, they haven't been assigned a tour, see if they've made
		 * the appropraite selection(s) */
		if( ($n_tours >= $config['tours_choices_min']) && ($n_tours <= $config['tours_choices_max']) ){
			continue;
		}
		$ret = "incomplete";
		break;
	}
	return $ret;
}
function namecheckStatus($reg_id="")
{
	global $conference;

	if($reg_id) {
		$q=mysql_query("SELECT * FROM students WHERE 
				registrations_id='$reg_id' 
				AND conferences_id='".$conference['id']."'");
	} else {
		$q=mysql_query("SELECT * FROM students WHERE 
				id='{$_SESSION['students_id']}'");
	}

	/* Get the students for this project */
	while($s=mysql_fetch_object($q)) {
		if($s->namecheck_complete == 'no') {
			return 'incomplete';
		}
	}
	return 'complete';
}


function generateProjectNumber($registration_id)
{
	global $config, $conference;

	$reg_id = $registration_id;
	
	$q=mysql_query("SELECT 	projects.projectcategories_id, 
				projects.projectdivisions_id,
				projectcategories.category_shortform,
				projectdivisions.division_shortform
			FROM 
				projects,
				projectcategories,
				projectdivisions
			WHERE 
				registrations_id='$reg_id'
			AND	projects.projectdivisions_id=projectdivisions.id
			AND	projects.projectcategories_id=projectcategories.id
			AND	projectcategories.conferences_id='{$conference['id']}'
			AND	projectdivisions.conferences_id='{$conference['id']}'
				");
				echo mysql_error();
	$r=mysql_fetch_object($q);

	$p=array('number'=>array(), 'sort'=>array() );
	$p['number']['str'] = $config['project_num_format'];
	$p['sort']['str'] = trim($config['project_sort_format']);

	if($p['sort']['str'] == '') $p['sort']['str'] = $p['number']['str'];

	/* Replace each letter with {letter}, so that we can do additional
	 * replacements below, without risking subsituting in a letter that may
	 * get replaced. */
	foreach(array('number','sort') as $x) {
		$p[$x]['str']=ereg_replace('[CcDd]', '{\\0}', $p[$x]['str']);
		$p[$x]['str']=ereg_replace('(N|X)([0-9])?', '{\\0}', $p[$x]['str']);
	}

	/* Do some replacements that we don' thave to do anything fancy with,
	 * and setup some variables for future queries */
	foreach(array('number','sort') as $x) {
		$p[$x]['str']=str_replace('{D}',$r->projectdivisions_id,$p[$x]['str']);
		$p[$x]['str']=str_replace('{C}',$r->projectcategories_id,$p[$x]['str']);
		$p[$x]['str']=str_replace('{d}',$r->division_shortform,$p[$x]['str']);
		$p[$x]['str']=str_replace('{c}',$r->category_shortform,$p[$x]['str']);
		$p[$x]['n_used'] = array();
		$p[$x]['x_used'] = array();
	}

	/* Build a total list of projects for finding a global number, and
	 * while constructing the list, build a list for the division/cat 
	 * sequence number */
	$q = mysql_query("SELECT projectnumber_seq,projectsort_seq,
				projectdivisions_id,projectcategories_id 
			FROM projects 
			WHERE conferences_id='{$conference['id']}'
				AND projectnumber_seq!='0'
				AND projectnumber IS NOT NULL");
	echo mysql_error();
	while($i = mysql_fetch_object($q)) {
		if( ($r->projectdivisions_id == $i->projectdivisions_id)
		  &&($r->projectcategories_id == $i->projectcategories_id) ) {
			$p['number']['n_used'][] = $i->projectnumber_seq;
			$p['sort']['n_used'][] = $i->projectsort_seq;
		}

		$p['number']['x_used'][] = $i->projectnumber_seq;
		$p['sort']['x_used'][] = $i->projectsort_seq;
	}
	
	/* We only support one N or X to keep things simple, find which
	 * one we need and how much to pad it */
	foreach(array('number','sort') as $x) {
		if(ereg("(N|X)([0-9])?", $p[$x]['str'], $regs)) {
			$p[$x]['seq_type'] = $regs[1];
			if($regs[2] != '') 
				$p[$x]['seq_pad'] = $regs[2];
			else
				$p[$x]['seq_pad'] = ($regs[1] == 'N') ? 2 : 3;

			if($regs[1] == 'N') 
				$p[$x]['used'] = $p[$x]['n_used'];
			else 
				$p[$x]['used'] = $p[$x]['x_used'];
		} else {
			/* FIXME: maybe we should error here?  Not having an N
			 * or an X in the projectnumber or projectsort is a bad
			 * thing */
			$p[$x]['seq_type'] = '';
			$p[$x]['seq_pad'] = 0;
			$p[$x]['used'] = array();
		}
	}

	/* Find the lowest unused number.  FIXME: this could be a config
	 * option, we could search for the lowest unused number (if projects
	 * get deleted), or we could just go +1 beyond the highest */
	foreach(array('number','sort') as $x) {
		if($p[$x]['seq_type'] == '') continue;
		$n = 0;
		while(1) {
			$n++;
			if(in_array($n, $p[$x]['used'])) continue;

			$r = sprintf("%'0{$p[$x]['seq_pad']}d", $n);
			$str = ereg_replace("{(N|X)([0-9])?}", $r, $p[$x]['str']);
			$p[$x]['str'] = $str;
			$p[$x]['n'] = $n;
			break;
		}

		/* If we're using the same number type for sorting, then we, in
		 * theory, know what that number is, so we can go ahead and
		 * blindly use it */
		if($p['number']['seq_type'] == $p['sort']['seq_type']) {
			$r = sprintf("%'0{$p['sort']['seq_pad']}d", $n);
			$p['sort']['str'] = ereg_replace("{(N|X)([0-9])?}", $r, $p['sort']['str']);
			$p['sort']['n'] = $n;
			break;
		}
	}

	return array($p['number']['str'], $p['sort']['str'],
			$p['number']['n'], $p['sort']['n']);
}

function computeRegistrationFee($regid)
{
	global $config, $conference;
	$ret = array();

	$regfee_items = array();
	$q = mysql_query("SELECT * FROM regfee_items
				WHERE conferences_id='{$conference['id']}'");
	while($i = mysql_fetch_assoc($q)) $regfee_items[] = $i;

	$q=mysql_query("SELECT * FROM students WHERE registrations_id='$regid' AND conferences_id='".$conference['id']."'");
	$n_students = mysql_num_rows($q);
	$n_tshirts = 0;
	$sel = array();
	while($s = mysql_fetch_object($q)) {
		if($s->tshirt != 'none') $n_tshirts++;

		/* Check their regfee items too */
		if($config['participant_regfee_items_enable'] != 'yes') continue;

		$sel_q = mysql_query("SELECT * FROM regfee_items_link 
					WHERE students_id={$s->id}");
		while($info_q = mysql_fetch_assoc($sel_q)) {
			$sel[] = $info_q['regfee_items_id'];
		}
	}

	if($config['regfee_per'] == 'student') {
		$f = $config['regfee'] *  $n_students;
		$ret[] = array( 'id' => 'regfee',
				'text' => "Fair Registration (per student)",
				'base' => $config['regfee'],
				'num' => $n_students,
				'ext' => $f );
		$regfee += $f; 
	} else {
		$ret[] = array( 'id' => 'regfee',
				'text' => "Fair Registration (per project)",
				'base' => $config['regfee'],
				'num' => 1,
				'ext' => $config['regfee'] );
		$regfee += $config['regfee'];
	}

	if($config['participant_student_tshirt'] == 'yes') {
		$tsc = floatval($config['participant_student_tshirt_cost']);
		if($tsc != 0.0) {
			$f = $n_tshirts * $tsc;
			$regfee += $f;
			if($n_tshirts != 0) {
				$ret[] = array( 'id' => 'tshirt',
						'text' => "T-Shirts",
						'base' => $tsc,
						'num' => $n_tshirts,
						'ext' => $f);
			} 
		}
	}

	/* $sel will be empty if regfee_items is disabled */
	foreach($regfee_items as $rfi) {
		$cnt = 0;
		foreach($sel as $s) if($rfi['id'] == $s) $cnt++;

		if($cnt == 0) continue;

		$tsc = floatval($rfi['cost']);

		/* If it's per project, force the count to 1 */
		if($rfi['per'] == 'project') {
			$cnt = 1;
		}

		$f = $tsc * $cnt;
		$ret[] = array( 'id' => "regfee_item_{$rfi['id']}",
				'text' => "{$rfi['name']} (per {$rfi['per']})" ,
				'base' => $tsc,
				'num' => $cnt,
				'ext' => $f);
		$regfee += $f;
	}
	return array($regfee, $ret);
}

/******************************************************************************
New functionality split off for API purposes
******************************************************************************/

function saveProjectData($data){
	global $conference, $config;
	$requiredFields = array('project_id', 'summary', 'title', 'projectdivisions_id', 'language', 'req_table', 'req_electricity', 'summary');
	if($config['participant_short_title_enable'] == 'yes'){
		$requiredFields[] = 'shorttitle';
	}
	$missingFields = array();
	foreach($requiredFields as $field){
		if(!array_key_exists($field, $data)){
			$missingFields[] = $field;
		}else if(trim($data[$field]) == ''){
			$missingFields[] = $field;
		}
	}

	if(registrationFormsReceived()){
		$message =  i18n("Cannot make changes to forms once they have been received by the fair");
	}else if(registrationDeadlinePassed()){
		$message = i18n("Cannot make changes to forms after registration deadline");
	}else if(count($missingFields)){
		$message = i18n("Required fields missing: %1", array(implode(', ', $missingFields)));
	}else{
		//first, lets make sure this project really does belong to them
		$q = mysql_query("SELECT * FROM projects WHERE id='" . $data['project_id'] . "' AND registrations_id='" . $_SESSION['registration_id'] . "' AND conferences_id='" . $conference['id'] . "'");
		if(mysql_num_rows($q) == 1)
		{
			$summarywords = preg_split("/[\s,]+/", $data['summary']);
			$summarywordcount = count($summarywords);
			if($summarywordcount > $config['participant_project_summary_wordmax'] || $summarywordcount<$config['participant_project_summary_wordmin'])
				$summarycountok=0;
			else
				$summarycountok=1;

			if($config['participant_project_title_charmax'] && strlen($data['title'])>$config['participant_project_title_charmax'])  //0 for no limit, eg 255 database field limit
			{
				$title=substr($data['title'],0,$config['participant_project_title_charmax']);
				$message = i18n("Project title truncated to %1 characters",array($config['participant_project_title_charmax']));
			}
			else
				$title=$data['title'];

			if($config['participant_short_title_enable'] == 'yes'
			   && $config['participant_short_title_charmax'] 
			   && strlen($data['shorttitle'])>$config['participant_short_title_charmax'])  //0 for no limit, eg 255 database field limit
			{
				$shorttitle=substr($data['shorttitle'],0,$config['participant_short_title_charmax']);
				$message = i18n("Short project title truncated to %1 characters",array($config['participant_short_title_charmax']));
			}
			else
				$shorttitle=$data['shorttitle'];

			mysql_query("UPDATE projects SET " .
				"title='" . mysql_real_escape_string($title)."', " .
				"shorttitle='" . mysql_real_escape_string($shorttitle) . "', " .
				"projectdivisions_id='" . $data['projectdivisions_id'] . "', " .
				"language='" . mysql_real_escape_string($data['language']) . "', " .
				"req_table='" . mysql_real_escape_string($data['req_table']) . "', " .
				"req_electricity='" . mysql_real_escape_string($data['req_electricity']) . "', " .
				"req_special='" . mysql_real_escape_string($data['req_special']) . "', " .
				"summary='" . mysql_real_escape_string($data['summary']) . "', " .
				"summarycountok='$summarycountok'" .
				"WHERE id='" . $data['project_id'] . "'");
			$message = mysql_error();
			if($message == ''){
				$message = 'success';
			}
		}
		else
		{
			$message = i18n("Invalid project to update");
		}
	}
	return $message;
}

//get a random registration number between 100000 and 999999  (six digit integer)
// that isn't already in use
//TODO - set up a method of ensuring that the very unlikely chance of two people simultaneously
// getting the same number is in fact impossible
function getNewRegNum(){
	global $conference;
	do {
		$regnum = rand(100000,999999);
		$q = mysql_query("SELECT * FROM registrations WHERE num='$regnum' AND conferences_id=".$conference['id']);
	}while(mysql_num_rows($q) > 0);
	return $regnum;
}

// add a registration record and return it's unique "num" id
// returns an error message if the user is alredy registered
function addRegistration($userId){
	global $conference;

	// first we make sure that they don't already have a project on the go
	$query = mysql_query("SELECT * FROM users WHERE id = $userId");
	$err = mysql_error();
	if($err){
		return "register_participants.inc.php::addRegistration -> " . $err;
	}

	$row = mysql_fetch_assoc($query);
	if(!$row){
		return "register_participants.inc.php::addRegistration -> user not found";
	}

	if($row['registrations_id'] != null){
		return "register_participants.inc.php::addRegistration -> user already has a project registered";
	}

	// create the new registration record, and assign a random/unique registration number.
	$regnum = getNewRegNum();

	//actually insert it
	$query = "INSERT INTO registrations (num,email,start,status,conferences_id) VALUES (".
			"'$regnum', ".
			"'".$_SESSION['email']."', ".
			"NOW(), ".
			"'new', ".
			$conference['id'].
			")";
	mysql_query($query);
	$err = mysql_error();
	if($err){
		return "register_participants.inc.php::addRegistration -> " . $err;
	}

	// update the user now, connecting them to that registration
	$query = "UPDATE users SET registrations_id = $regnum WHERE id = $userId";
	mysql_query($query);
	$err = mysql_error();
	if($err){
		return "register_participants.inc.php::addRegistration -> " . $err;
	}

	// ok, if the flow hits this point, then we've successfully added the registration and
	// linked the user to it.  Return the registration number
	return $regnum;
}

function getProject($registrations_id){
	global $conference;
	// FIXME - in the future, this should be able to handle a many-to-many
	// relationship in projects to registrations (so remove that LIMIT 1)
	$fields = implode(',', array(
		'id', 'projectdivisions_id', 'title', 'language', 'req_electricity',
		'registrations_id', 'req_table', 'req_special', 'summary'
	));
	$q = mysql_query("SELECT $fields FROM projects WHERE registrations_id='$registrations_id' AND conferences_id='".$conference['id']."' LIMIT 1");
	if(mysql_error()) {
		$returnval = "register_participants.inc.php::getProject -> " . $returnval;
	}else{
		$returnval = mysql_fetch_assoc($q);
	}
	return $returnval;
}

// add a project
function addProject($registrations_id){
	global $conference;
 	mysql_query("
		INSERT INTO projects(registrations_id, conferences_id)
		VALUES ('" . $registrations_id . "','" . $conference['id']."')
	"); 
	//now query the one we just inserted
 	$q = mysql_query("SELECT * FROM projects WHERE registrations_id='$registrations_id' AND conferences_id='{$conference['id']}'");
	if(mysql_error()) {
		$returnval = "register_participants.inc.php::addProject -> " . $returnval;
	}else{
		$returnval = mysql_fetch_assoc($q);
	}
	return $returnval;
}


?>
